  --=========================================================================
           -- project.lua
           -- For use with the SIMION8.1 simulations for a simple electron detector setup
           -- This program deterimines the fraction of simulated electrons that actualy hit the
           -- detector surface and writes the corresponding collection efficiency to the log.

         
  --=========================================================================


    simion.workbench_program()
		   
		-- these are the coordinates of the detector volume (cylinder oriented in x direction). 
        -- Adjust them to your geometry! Electrons splatting in this volume are interpretd
		-- as being detected and are considered in the computed collection efficiency.
		
        adjustable detector_M_y = 0				-- detector center coordinate (y)
        adjustable detector_M_z = 0				-- detector center coordinate (z)
        adjustable detector_x = 0				-- detector position coordinate (x)
           
		local detector_radius= 6				-- detector radius
		local cylinder_h=4						-- detector cylinder height
		local number_of_hits = 0				-- variable used to store no. of el. collected
        local number_of_particles = 0			-- no. of simulated particles
		
		-- The following function is used to deterimine wether an electron splats on the detector
		-- surface or not.
		
		function circle(x,y,z)
            if (detector_x-cylinder_h/2) <= x then
				if x <= (detector_x+cylinder_h/2) then
					if ((y-detector_M_y)^2+(z-detector_M_z)^2) <= (detector_radius^2) then
						return 1
					end
				end
			end
        end
		
		function segment.initialize()
            number_of_particles = number_of_particles + 1		-- this variable counts the number of simulated particles
        end
		
		function segment.terminate()

        -- If the terminated particle ends up in the detector volume it is interpreted as a
        -- detected particle.
            if circle(ion_px_mm, ion_py_mm, ion_pz_mm) == 1 then
                number_of_hits = number_of_hits + 1
            end

            if ion_number < number_of_particles then return end -- Output only on last ion

            local efficiency = (number_of_hits * 100)/number_of_particles  -- here the collection efficiency is determined
            
            print("collection efficiency:" .. efficiency .. "\n")
        end